﻿using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Windows;
using ThinkGeo.MapSuite;
using ThinkGeo.MapSuite.Drawing;
using ThinkGeo.MapSuite.Layers;
using ThinkGeo.MapSuite.Shapes;
using ThinkGeo.MapSuite.Styles;

namespace WpfApp1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            Test();
        }

        private void Test()
        {
            InMemoryFeatureLayer imfl = new InMemoryFeatureLayer();
            string offsetName = "name";

            Stopwatch s = new Stopwatch();

            //Leo: this logic might be wrong, please correct it accordingly, thanks.
            ConcurrentDictionary<double, MultipolygonShape> allBins = new ConcurrentDictionary<double, MultipolygonShape>();
            Random r = new Random();
            for (int i = 0; i < 27000000; i++)
            {
                double value = r.NextDouble() * 10 + 0;
                allBins.TryAdd(value, new MultipolygonShape("MULTIPOLYGON (((30 20, 10 40, 45 40, 30 20)), ((15 5, 40 10, 10 20, 5 10, 15 5)))"));
            }

            
            int maxpg = 15000000;
            foreach (var pg in allBins)
            {
                if (pg.Value.Polygons.Count == 0) continue;

                if (pg.Value.Polygons.Count > maxpg)
                {
                    int fc = Convert.ToInt32(Math.Ceiling(pg.Value.Polygons.Count / (float)maxpg));
                    for (int i = 0; i < fc; i++)
                    {
                        List<PolygonShape> pgs = pg.Value.Polygons.Skip(i * maxpg).Take(maxpg).ToList();
                        MultipolygonShape mpg = new MultipolygonShape(pgs);
                        imfl.InternalFeatures.Add(new Feature(mpg, new List<string>() { offsetName + ":" + pg.Key }));
                    }
                }
                else
                    imfl.InternalFeatures.Add(new Feature(pg.Value, new List<string>() { offsetName + ":" + pg.Key }));
            }

            Debug.Print(string.Format("Adding bins to imfl took {0:0.0} s", s.Elapsed.Seconds));
            s.Restart();

            imfl.Open();
            RectangleShape rect = imfl.GetBoundingBox();

            // Have to set map size first otherwise it is taking forever if the data are already loaded
            double mapX = rect.LowerRightPoint.X - rect.LowerLeftPoint.X;

            //double minBin = model.GridDef.BinX;
            //if (model.GridDef.BinY < model.GridDef.BinX)
            //    minBin = model.GridDef.BinY;

            // Leo: not sure what value minBin shoudl be, please advise a value 
            double minBin = 0.00000004;

            double ratio = 16 / 9f;
            ratio = rect.Width / rect.Height;

            int w = 5120;
            int h = Convert.ToInt32(w / ratio);

            double pixelsPerBin = minBin * w / mapX;

            while (pixelsPerBin < 4)
            {
                w += 100;
                h = Convert.ToInt32(w / ratio);

                double imageSize = w * h * 4f;
                if (imageSize >= 2.147483648e9)
                {
                    w -= 100;
                    h = Convert.ToInt32(w / ratio);
                    break;
                }

                pixelsPerBin = minBin * w / mapX;
            }

            // Bitmap can't exceed 65535 x 65535
            if (h >= 65535)
            {
                h = 65535;
                w = Convert.ToInt32(h * ratio);
            }

            Debug.Print(string.Format("Building map took {0:0.0} s", s.Elapsed.Seconds));
            s.Restart();

            using (Bitmap bitmap = new Bitmap(w, h))
            {
                PlatformGeoCanvas canvas = new PlatformGeoCanvas();
                canvas.BeginDrawing(bitmap, rect, GeographyUnit.Meter);
                imfl.Draw(canvas, new Collection<SimpleCandidate>());
                canvas.EndDrawing();
                bitmap.Save("aa.png", System.Drawing.Imaging.ImageFormat.Png);
            }
        }
    }
}
